"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("manate/react");
var react_2 = __importStar(require("react"));
var split_grid_1 = __importDefault(require("split-grid"));
var styles = __importStar(require("../css/index.module.scss"));
var editor_1 = __importDefault(require("./editor"));
var modals_1 = __importDefault(require("./modals"));
var toolbar_1 = __importDefault(require("./toolbar"));
var Layout = function (props) {
    var store = props.store;
    var preferences = store.preferences;
    var colGutter = (0, react_2.createRef)();
    (0, react_2.useEffect)(function () {
        if (!colGutter.current)
            return;
        (0, split_grid_1.default)({
            columnGutters: [
                {
                    track: 1,
                    element: colGutter.current,
                },
            ],
            snapOffset: 64,
        });
    }, [colGutter]);
    var gridTemplateRows = '0 0 1fr';
    if (preferences.toolbar === 'show') {
        gridTemplateRows = '20px 6px 1fr';
    }
    else if (preferences.toolbar === 'hide') {
        gridTemplateRows = '0 6px 1fr';
    }
    var gridTemplateColumns = '1fr 6px 1fr';
    if (preferences.mode === 'editor') {
        gridTemplateColumns = '1fr 0 0';
    }
    else if (preferences.mode === 'preview') {
        gridTemplateColumns = '0 0 1fr';
    }
    var theme = preferences.theme;
    if (theme === 'auto') {
        theme = window.matchMedia('(prefers-color-scheme: dark)').matches
            ? 'dark'
            : 'light';
    }
    return (react_2.default.createElement("div", { className: styles['markplus'], "data-theme": theme },
        react_2.default.createElement("div", { className: "rows-grid", style: { gridTemplateRows: gridTemplateRows } },
            react_2.default.createElement(toolbar_1.default, { store: store }),
            react_2.default.createElement("div", { className: "gutter row-gutter", title: preferences.toolbar === 'hide' ? 'Show toolbar' : 'Hide toolbar', onClick: function () {
                    return (preferences.toolbar =
                        preferences.toolbar === 'hide' ? 'show' : 'hide');
                } }),
            react_2.default.createElement("div", { className: "cols-grid", style: { gridTemplateColumns: gridTemplateColumns } },
                react_2.default.createElement("div", { className: "left-panel" },
                    react_2.default.createElement(editor_1.default, { store: store })),
                react_2.default.createElement("div", { className: "gutter col-gutter", title: "Resize", ref: colGutter }),
                react_2.default.createElement("div", { className: "right-panel" },
                    react_2.default.createElement("article", { className: "markdown-body preview" })))),
        react_2.default.createElement(modals_1.default, { store: store })));
};
exports.default = (0, react_1.auto)(Layout);
//# sourceMappingURL=layout.js.map