"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var antd_1 = require("antd");
var react_1 = require("manate/react");
var react_2 = __importStar(require("react"));
var PromptModals = function (props) {
    var store = props.store;
    var modals = store.modals;
    var emojiInput = (0, react_2.useRef)(null);
    var faInput = (0, react_2.useRef)(null);
    var _a = (0, react_2.useState)(''), emojiValue = _a[0], setEmojiValue = _a[1];
    var _b = (0, react_2.useState)(''), faValue = _b[0], setFaValue = _b[1];
    var handleEmojiOK = function () {
        modals.emoji.close();
        var value = emojiValue.trim();
        if (value.length > 0) {
            var editor = store.editor;
            var mainSelection = editor.state.selection.main;
            editor.dispatch({
                changes: {
                    from: mainSelection.from,
                    to: mainSelection.to,
                    insert: ":".concat(value, ":"),
                },
                selection: { anchor: mainSelection.head + value.length + 2 },
            });
        }
        setEmojiValue('');
    };
    var handleFaOK = function () {
        modals.fontAwesome.close();
        var value = faValue.trim();
        if (value.length > 0) {
            var editor = store.editor;
            var mainSelection = editor.state.selection.main;
            editor.dispatch({
                changes: {
                    from: mainSelection.from,
                    to: mainSelection.to,
                    insert: ":fa-".concat(value, ":"),
                },
                selection: { anchor: mainSelection.head + value.length + 5 },
            });
        }
        setFaValue('');
    };
    return (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(antd_1.Modal, { open: modals.emoji.isOpen, onCancel: function () { return modals.emoji.close(); }, onOk: function () { return handleEmojiOK(); }, maskClosable: true, centered: true, afterOpenChange: function (open) {
                var _a;
                if (open) {
                    (_a = emojiInput.current) === null || _a === void 0 ? void 0 : _a.focus();
                }
            } },
            react_2.default.createElement("div", { style: { textAlign: 'center' } },
                react_2.default.createElement("p", null,
                    react_2.default.createElement("img", { src: "https://chuntaoliu.com/markplus/icon.svg", width: "64" })),
                react_2.default.createElement("h2", null, "Please enter an emoji code:"),
                react_2.default.createElement("p", null, "Examples: \"smile\", \"whale\", \"santa\", \"panda_face\", \"dog\", \"truck\"\n..."),
                react_2.default.createElement("p", null,
                    "For a complete list, please check",
                    ' ',
                    react_2.default.createElement("a", { href: "https://github.com/ikatyang/emoji-cheat-sheet/blob/master/README.md", target: "_blank", rel: "noreferrer" }, "Emoji Cheat Sheet"),
                    "."),
                react_2.default.createElement("div", null,
                    react_2.default.createElement(antd_1.Input, { ref: emojiInput, value: emojiValue, onChange: function (e) { return setEmojiValue(e.target.value); }, placeholder: "smile", onKeyUp: function (e) {
                            if (e.key === 'Enter') {
                                handleEmojiOK();
                            }
                        } })))),
        react_2.default.createElement(antd_1.Modal, { open: modals.fontAwesome.isOpen, onCancel: function () { return modals.fontAwesome.close(); }, onOk: function () { return handleFaOK(); }, maskClosable: true, centered: true, afterOpenChange: function (open) {
                var _a;
                if (open) {
                    (_a = faInput.current) === null || _a === void 0 ? void 0 : _a.focus();
                }
            } },
            react_2.default.createElement("div", { style: { textAlign: 'center' } },
                react_2.default.createElement("p", null,
                    react_2.default.createElement("img", { src: "https://chuntaoliu.com/markplus/icon.svg", width: "64" })),
                react_2.default.createElement("h2", null, "Please enter a Font Awesome code:"),
                react_2.default.createElement("p", null, "Examples: \"cloud\", \"flag\", \"car\", \"truck\", \"heart\", \"dollar\" ..."),
                react_2.default.createElement("p", null,
                    "For a complete list, please check",
                    ' ',
                    react_2.default.createElement("a", { href: "https://github.com/gluons/Font-Awesome-Icon-Chars/blob/master/character-list/character-list.yaml", target: "_blank", rel: "noreferrer" }, "Font Awesome Icons"),
                    "."),
                react_2.default.createElement("div", null,
                    react_2.default.createElement(antd_1.Input, { ref: faInput, placeholder: "heart", value: faValue, onChange: function (e) { return setFaValue(e.target.value); }, onKeyUp: function (e) {
                            if (e.key === 'Enter') {
                                handleFaOK();
                            }
                        } }))))));
};
exports.default = (0, react_1.auto)(PromptModals);
//# sourceMappingURL=prompt.js.map