import { Compartment } from '@codemirror/state';
import { EditorView } from '@codemirror/view';
import { ReactElement } from 'react';
declare class Modal {
    isOpen: boolean;
    open(): void;
    close(): void;
}
declare class Preferences {
    mode: 'editor' | 'preview' | 'both';
    toolbar: 'show' | 'hide' | 'none';
    theme: 'light' | 'dark' | 'auto';
    toolbarItems: (string | ReactElement)[];
}
export declare class Store {
    editor: EditorView;
    editorTheme: Compartment;
    modals: {
        about: Modal;
        emoji: Modal;
        fontAwesome: Modal;
    };
    preferences: Preferences;
    applyTheme(): void;
}
declare const store: Store;
export default store;
