"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Store = void 0;
var state_1 = require("@codemirror/state");
var codemirror_theme_github_1 = require("@uiw/codemirror-theme-github");
var manate_1 = require("manate");
var Modal = /** @class */ (function () {
    function Modal() {
        this.isOpen = false;
    }
    Modal.prototype.open = function () {
        this.isOpen = true;
    };
    Modal.prototype.close = function () {
        var _a;
        this.isOpen = false;
        (_a = store.editor) === null || _a === void 0 ? void 0 : _a.focus();
    };
    return Modal;
}());
var Preferences = /** @class */ (function () {
    function Preferences() {
        this.mode = 'both';
        this.toolbar = 'show';
        this.theme = 'auto';
        this.toolbarItems = [];
    }
    return Preferences;
}());
var Store = /** @class */ (function () {
    function Store() {
        this.editorTheme = (0, manate_1.exclude)(new state_1.Compartment());
        this.modals = {
            about: new Modal(),
            emoji: new Modal(),
            fontAwesome: new Modal(),
        };
        this.preferences = new Preferences();
    }
    Store.prototype.applyTheme = function () {
        var darkTheme = this.preferences.theme === 'dark' ||
            (this.preferences.theme === 'auto' &&
                window.matchMedia('(prefers-color-scheme: dark)').matches);
        // editor theme
        this.editor.dispatch({
            effects: this.editorTheme.reconfigure(darkTheme ? codemirror_theme_github_1.githubDark : codemirror_theme_github_1.githubLight),
        });
    };
    return Store;
}());
exports.Store = Store;
var store = (0, manate_1.manage)(new Store());
exports.default = store;
//# sourceMappingURL=store.js.map